;;; DO NOT MODIFY THIS FILE
(if (featurep 'pcl-cvs-autoloads) (error "Already loaded"))

;;;### (autoloads nil "_pkg" "pcl-cvs/_pkg.el")

(package-provide 'pcl-cvs :version 1.66 :author-version "R-2_9_9" :type 'regular)

;;;***

;;;### (autoloads (cvs-edit) "cvs-edit" "pcl-cvs/cvs-edit.el")

(autoload 'cvs-edit "cvs-edit" "\
Setup a buffer to enter a log message.
The buffer will be put in `cvs-edit-mode'.
If SETUP is non-nil, the buffer is then erased and `cvs-edit-hook' is run.
Mark and point will be set around the entire contents of the
buffer so that it is easy to kill the contents of the buffer with \\[kill-region].
Once you're done editing the message, pressing \\[cvs-edit-done] will call
`cvs-edit-done' which will end up calling CALLBACK to do the actual commit." nil nil)

;;;***

;;;### (autoloads nil "cvs-log" "pcl-cvs/cvs-log.el")

(autoload 'cvs-log-mode "cvs-log" "\
Major mode for browsing CVS log output." t)

;;;***

;;;### (autoloads nil "cvs-status" "pcl-cvs/cvs-status.el")

(autoload 'cvs-status-mode "cvs-status" "\
Mode used for cvs status output." t)

;;;***

;;;### (autoloads nil "pcl-cvs-defs" "pcl-cvs/pcl-cvs-defs.el")

(if (progn (condition-case nil (require 'easymenu) (error nil)) (fboundp 'easy-menu-add-item)) (easy-menu-add-item nil '("tools") '("PCL CVS" ["Update Directory" cvs-update t] ["Examine Directory" cvs-examine t] ["Status Directory" cvs-status t] ["Checkout Module" cvs-checkout t]) "vc"))

;;;***

;;;### (autoloads (cvs-status cvs-update cvs-examine cvs-quickdir cvs-checkout) "pcl-cvs" "pcl-cvs/pcl-cvs.el")

(autoload 'cvs-checkout "pcl-cvs" "\
Run a 'cvs checkout MODULES' in DIR.
Feed the output to a *cvs* buffer, display it in the current window,
and run `cvs-mode' on it.

With a prefix argument, prompt for cvs FLAGS to use." t nil)

(autoload 'cvs-quickdir "pcl-cvs" "\
Open a *cvs* buffer on DIR without running cvs.
With a prefix argument, prompt for a directory to use.
A prefix arg >8 (ex: \\[universal-argument] \\[universal-argument]),
  prevents reuse of an existing *cvs* buffer.
Optional argument NOSHOW if non-nil means not to display the buffer.
FLAGS is ignored." t nil)

(autoload 'cvs-examine "pcl-cvs" "\
Run a `cvs -n update' in the specified DIRECTORY.
That is, check what needs to be done, but don't change the disc.
Feed the output to a *cvs* buffer and run `cvs-mode' on it.
With a prefix argument, prompt for a directory and cvs FLAGS to use.
A prefix arg >8 (ex: \\[universal-argument] \\[universal-argument]),
  prevents reuse of an existing *cvs* buffer.
Optional argument NOSHOW if non-nil means not to display the buffer." t nil)

(autoload 'cvs-update "pcl-cvs" "\
Run a `cvs update' in the current working DIRECTORY.
Feed the output to a *cvs* buffer and run `cvs-mode' on it.
With a prefix argument, prompt for a directory and cvs FLAGS to use.
A prefix arg >8 (ex: \\[universal-argument] \\[universal-argument]),
  prevents reuse of an existing *cvs* buffer." t nil)

(autoload 'cvs-status "pcl-cvs" "\
Run a `cvs status' in the current working DIRECTORY.
Feed the output to a *cvs* buffer and run `cvs-mode' on it.
With a prefix argument, prompt for a directory and cvs FLAGS to use.
A prefix arg >8 (ex: \\[universal-argument] \\[universal-argument]),
  prevents reuse of an existing *cvs* buffer.
Optional argument NOSHOW if non-nil means not to display the buffer." t nil)

(add-to-list 'completion-ignored-extensions "CVS/")

(defcustom cvs-dired-action 'cvs-examine "The action to be performed when opening a CVS directory.\nSensible values are `cvs-examine' and `cvs-status'." :group 'pcl-cvs :type '(choice (const cvs-examine) (const cvs-status)))

(defcustom cvs-dired-use-hook '(4) "Whether or not opening a CVS directory should run PCL-CVS.\nnil means never do it.\nALWAYS means to always do it unless a prefix argument is given to the\n  command that prompted the opening of the directory.\nAnything else means to do it only if the prefix arg is equal to this value." :group 'pcl-cvs :type '(choice (const :tag "Never" nil) (const :tag "Always" always) (const :tag "Prefix" (4))))

;;;***

(provide 'pcl-cvs-autoloads)
